# Contributing

First, if you're not yet familiar on how to contribute to open source, you might want to watch this short viedo.

{% embed url="<https://www.youtube.com/watch?v=8lGpZkjnkt4>" %}

First thing you want to do is fork the [keycloakify](https://github.com/keycloakify/keycloakify) and the [keycloakify-starter](https://github.com/keycloakify/keycloakify-starter) repos.

Here is how you can setup a development environment. You must use Yarn classic (v1).\
First you want to clone keycloakify and the keycloakify starter alongside each other

```bash
cd ~/github
git clone https://github.com/<your github username>/keycloakify
git clone https://github.com/<your github username>/keycloakify-starter
```

You can start the storybook locally in dev mode with:

```bash
cd ~/github/keycloakify
yarn
yarn storybook
```

If you want to test the changes you've made in keycloakify in the starter simply run

```bash
cd ~/github/keycloakify
yarn link-in-starter
```

In parallel you can:

```bash
cd ~/github/keycloakify-starter
yarn storybook
# or
npx keycloakify start-keycloak
```

And see the changes you make on the keycloakify project applied in the starter, it's all hot reloaded.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.keycloakify.dev/keycloakify/v10/faq-and-help/contributing.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
